/* IBMBUG.C */
#include <stdio.h>
#include <stdlib.h>


struct primitive_point
{  float b[2];
   float e[2];
};

int QuickConfluence(struct primitive_point *Prim, int Nprim);


struct primitive_point PPrim[4]=
{1, 2, 3, 4,5, 6, 7, 8};


int main()
{
   QuickConfluence(PPrim,1);
   return 0;
}


struct Vertex2DForSort
{  float vertex[2];
   int index;
   int v_ind;
};


int QuickConfluence(struct primitive_point *Prim, int Nprim)
{
static   struct Vertex2DForSort vfs[8];
static   int j,n,Num_vfs;

   for(n=0;n<Nprim;n++)
   {  printf("%f %f %f %f\n",Prim[n].b[0],Prim[n].b[1],Prim[n].e[0],Prim[n].e[1]);
   }
   printf("\n");

   Num_vfs=0;
   for(n=0;n<Nprim;n++)
   {  for(j=0;j<2;j++) vfs[Num_vfs].vertex[j] = Prim[n].b[j];
      vfs[Num_vfs].index = n;
      vfs[Num_vfs].v_ind = 0;
      Num_vfs++;

/* BAD loop */
      for(j=0;j<2;j++) vfs[Num_vfs].vertex[j] = Prim[n].e[j];
/* In case of hand-made loop unroll - Everything Ok
      vfs[Num_vfs].vertex[0] = Prim[n].e[0];
      vfs[Num_vfs].vertex[1] = Prim[n].e[1];
*/

      vfs[Num_vfs].index = n;
      vfs[Num_vfs].v_ind = 1;
      Num_vfs++;
   }

   for(n=0;n<Num_vfs;n++)
   {  printf("%f %f %i %i\n",vfs[n].vertex[0],vfs[n].vertex[1],vfs[n].index,vfs[n].v_ind);
   }

   if(vfs[0].vertex[0] == 1.f) printf("\nNO VAC++ bug");
   else                        printf("\nVAC++ BUG");
   return 0;
}

